Attribute VB_Name = "ASC_read"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: asc_read.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim meas_data As Variant, swp_prm As Variant
  Dim trc1 As Integer, nop As Integer
  Dim swp_bool As Integer, bool As Integer
  
  trc1 = 1
  nop = 201
  
  ' E4991A settings
  
  SCPI.Output "SYST:PRES"
  
  SCPI.Output "DISP:TRAC" & CStr(trc1) & " ON"
  SCPI.Output "SWE:POIN " & CStr(nop)
  
  SCPI.Output "TRIG:SOUR INT"
  SCPI.Output "INIT:CONT OFF"
  SCPI.Output "ABOR"
  
  swp_bool = SCPI.Query("CALC:AVER?")
  If swp_bool = 1 Then SCPI.Output "CALC:AVER:CLE"
  
  bool = SingleMeasure
  
  If bool = 0 Then
    MsgBox ("Sweep Aborted")
  ElseIf bool = 1 Then
    SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:AUTO"
    
    SCPI.Output "FORM:DATA ASC"
    
    SCPI.Output "CALC" & CStr(trc1) & ":DATA? FDATA"
    SCPI.Enter meas_data, "#"
    SCPI.Output "SWE:STIM3?"
    SCPI.Enter swp_prm, "#"
  End If
  
  End
End Sub

