Attribute VB_Name = "Bias_mon"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: bias_mon.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim meas_data As Variant, mon_bias As Variant, swp_prm As Variant
  Dim header As String, buff As String, img As String
  Dim start_bias As Double, stop_bias As Double, lim_bias As Double
  Dim cw_freq As Double, osc_level As Double
  Dim trc1 As Integer, trc2 As Integer, nop As Integer, swp_count As Integer
  Dim i As Integer, swp_bool As Integer, bool As Integer
  Dim fileNum As Integer
  Dim file As String
  
  trc1 = 1
  trc2 = 2
  start_bias = 0
  stop_bias = 40
  lim_bias = 0.05
  nop = 41
  swp_count = 1
  cw_freq = 100000000#
  osc_level = 0.1
  
  ' E4991A settings
  
  SCPI.Output "SYST:PRES"
  
  SCPI.Output "DISP:TRAC" & CStr(trc1) & " ON"
  SCPI.Output "DISP:TRAC" & CStr(trc2) & " OFF"
  SCPI.Output "CALC" & CStr(trc1) & ":FORM Z"
  
  SCPI.Output "SWE:TYPE DCV"
  SCPI.Output "SOUR:VOLT:OFFS:STAR " & CStr(start_bias)
  SCPI.Output "SOUR:VOLT:OFFS:STOP " & CStr(stop_bias)
  SCPI.Output "SOUR:CURR:LIM:OFFS " & CStr(lim_bias)
  SCPI.Output "SWE:POIN " & CStr(nop)
  SCPI.Output "SWE:DIR UP"
  SCPI.Output "CALC:AVER:COUN " & CStr(swp_count)
  SCPI.Output "CALC:AVER ON"
  
  SCPI.Output "FREQ " & CStr(cw_freq)
  SCPI.Output "SOUR:VOLT:MODE FIX"
  SCPI.Output "SOUR:VOLT " & CStr(osc_level)
  
  SCPI.Output "SOUR:VOLT:OFFS:STAT ON"
  SCPI.Output "CALC" & CStr(trc1) & ":MARK1 ON"
  SCPI.Output "CALC:BMON ON"
  
  SCPI.Output "TRIG:SOUR INT"
  SCPI.Output "INIT:CONT OFF"
  SCPI.Output "ABOR"
  
  swp_bool = SCPI.Query("CALC:AVER?")
  If swp_bool = 1 Then SCPI.Output "CALC:AVER:CLE"
  
  bool = SingleMeasure
  If bool = 0 Then
    MsgBox ("Sweep Aborted")
  ElseIf bool = 1 Then
    SCPI.Output "FORM:DATA ASC"
    
    SCPI.Output "CALC" & CStr(trc1) & ":DATA? FDATA"
    SCPI.Enter meas_data, "#"
    SCPI.Output "CALC" & CStr(trc1) & ":DATA:MON? V"
    SCPI.Enter mon_bias, "#"
    SCPI.Output "SWE:STIM3?"
    SCPI.Enter swp_prm, "#"
    
    file = "a:\mon_data.txt"
    fileNum = FreeFile
    Open file For Output As #fileNum
    Print #fileNum, "Bias Monitor Result"
    Print #fileNum, ""
    Print #fileNum, "DC Bias[V]     Z[ohm]                      Mon. Bias[V]"
    Print #fileNum, "--------------------------------------------------------------"
    For i = 1 To nop
      Print #fileNum, Val(swp_prm(i - 1)), Val(meas_data(i - 1)), Val(mon_bias(i - 1))
    Next i
    Close #fileNum
  End If
  
  End
End Sub


