Attribute VB_Name = "cal_inp"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: cal_inp.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************
    
Sub Main()
  Dim file As String
  Dim Cal_a1() As Double, Cal_a2() As Double
  Dim Cal_b1() As Double, Cal_b2() As Double
  Dim Cal_c1() As Double, Cal_c2() As Double
  Dim a1_data As String, a2_data As String
  Dim b1_data As String, b2_data As String
  Dim c1_data As String, c2_data As String
  Dim Corr As Integer, Nop_cal As Integer
  Dim iFileNo As Integer, i As Integer
    
  SCPI.Output "SENS:CORR1?"
  SCPI.Enter Corr
  If Corr = 0 Then
    MsgBox "It is unable to transfer calibration coefficient data to E4991A", vbOKOnly + vbExclamation, "Transfer"
    GoTo Prog_end
  End If
    
  SCPI.Output "SWE:POIN?"
  SCPI.Enter Nop_cal
            
  ReDim Cal_a1(1 To Nop_cal * 2), Cal_a2(1 To Nop_cal * 2)
  ReDim Cal_b1(1 To Nop_cal * 2), Cal_b2(1 To Nop_cal * 2)
  ReDim Cal_c1(1 To Nop_cal * 2), Cal_c2(1 To Nop_cal * 2)
            
  ' -> Load Data
    
  file = "a:\CAL_COEF"
  iFileNo = FreeFile
    
  Open file For Input As iFileNo
  For i = 1 To Nop_cal * 2
    Input #iFileNo, Cal_a1(i)
  Next i
  For i = 1 To Nop_cal * 2
    Input #iFileNo, Cal_b1(i)
  Next i
  For i = 1 To Nop_cal * 2
    Input #iFileNo, Cal_c1(i)
  Next i
  For i = 1 To Nop_cal * 2
    Input #iFileNo, Cal_a2(i)
  Next i
  For i = 1 To Nop_cal * 2
    Input #iFileNo, Cal_b2(i)
  Next i
  For i = 1 To Nop_cal * 2
    Input #iFileNo, Cal_c2(i)
  Next i
      
  Close #iFileNo
      
  data_a1 = Cal_a1(1)
  data_b1 = Cal_b1(1)
  data_c1 = Cal_c1(1)
  data_a2 = Cal_a2(1)
  data_b2 = Cal_b2(1)
  data_c2 = Cal_c2(1)
  For i = 2 To Nop_cal * 2
    data_a1 = data_a1 & "," & Cal_a1(i)
    data_b1 = data_b1 & "," & Cal_b1(i)
    data_c1 = data_c1 & "," & Cal_c1(i)
    data_a2 = data_a2 & "," & Cal_a2(i)
    data_b2 = data_b2 & "," & Cal_b2(i)
    data_c2 = data_c2 & "," & Cal_c2(i)
  Next i
      
  ' -> Input Calibration Data
    
  SCPI.Output "FORM:DATA ASC"
  SCPI.Output "DATA:CCO1 " & data_a1
  SCPI.Output "DATA:CCO2 " & data_b1
  SCPI.Output "DATA:CCO3 " & data_c1
  SCPI.Output "DATA:CCO4 " & data_a2
  SCPI.Output "DATA:CCO5 " & data_b2
  SCPI.Output "DATA:CCO6 " & data_c2
    
  MsgBox "Data Writing succeed!", vbOKOnly, "Transfer"
  
  End
  
Prog_end: End Sub
