Attribute VB_Name = "Cal_meas"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: cal_meas.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************
    
Sub Main()
  Dim buff As String, file As String
  Dim Cal_kit As String, Cal_point As String
  Dim Cal_a1 As Variant, Cal_a2 As Variant
  Dim Cal_b1 As Variant, Cal_b2 As Variant
  Dim Cal_c1 As Variant, Cal_c2 As Variant
  Dim Open_g As Double, Open_c As Double
  Dim Short_r As Double, Short_l As Double
  Dim Load_r As Double, Load_l As Double
  Dim Result As Integer, Nop_cal As Integer, Inp_char As Integer
  Dim iFileNo As Integer, i As Integer
    
  Cal_kit = "DEF"       'DEF/USER
  Cal_point = "FIX"     'FIX/FUS/USER
    
  SCPI.Output "SENS:CORR1:CKIT " & Cal_kit
  SCPI.Output "SENS:CORR1:COLL:FPO " & Cal_point
    
  If Cal_kit = "USER" Then
        
    SCPI.Output "SENS:CORR1:CKIT:LIST OFF"
        
    Call Inp_data("Open_G(S)", Open_g)
    Call Inp_data("Open_C(F)", Open_c)
    SCPI.Output "SENS:CORR1:CKIT:STAN1:G " & CStr(Open_g)
    SCPI.Output "SENS:CORR1:CKIT:STAN1:C " & CStr(Open_c)
        
    Call Inp_data("Short_R(ohm)", Short_r)
    Call Inp_data("Short_L(H)", Short_l)
    SCPI.Output "SENS:CORR1:CKIT:STAN2:R " & CStr(Short_r)
    SCPI.Output "SENS:CORR1:CKIT:STAN2:L " & CStr(Short_l)
        
    Call Inp_data("Load_R(ohm)", Load_r)
    Call Inp_data("Load_L(H)", Load_l)
    SCPI.Output "SENS:CORR1:CKIT:STAN3:R " & CStr(Load_r)
    SCPI.Output "SENS:CORR1:CKIT:STAN3:L " & CStr(Load_l)
        
  End If
    
  Result = Cal("Open")
  If Result <> 0 Then GoTo Prog_end
  
  Result = Cal("Short")
  If Result <> 0 Then GoTo Prog_end
  
  Result = Cal("Load")
  If Result <> 0 Then GoTo Prog_end
  
  Inp_char = MsgBox("Do you want to measure a Low-Loss Capacitor?", vbYesNo + vbQuestion, "Calibration")
  If Inp_char = vbYes Then
    Result = Cal("Low-loss C")
    If Result <> 0 Then GoTo Prog_end
  End If
    
  SCPI.Output "SENS:CORR1:COLL:SAVE"
  buff = SCPI.Query("*OPC?")
  MsgBox "All cal-data measurement completion", vbOKOnly, "Calibration"
    
  SCPI.Output "FORM:DATA ASC"
  SCPI.Output "DATA:CCO1?"
  SCPI.Enter Cal_a1, "#"
  SCPI.Output "DATA:CCO2?"
  SCPI.Enter Cal_b1, "#"
  SCPI.Output "DATA:CCO3?"
  SCPI.Enter Cal_c1, "#"
  SCPI.Output "DATA:CCO4?"
  SCPI.Enter Cal_a2, "#"
  SCPI.Output "DATA:CCO5?"
  SCPI.Enter Cal_b2, "#"
  SCPI.Output "DATA:CCO6?"
  SCPI.Enter Cal_c2, "#"
    
  SCPI.Output "SWE:POIN?"
  SCPI.Enter Nop_cal
        
  iFileNo = FreeFile
  file = "a:\CAL_COEF"
      
  Open file For Output As iFileNo
  For i = 1 To Nop_cal * 2
    Write #iFileNo, Val(Cal_a1(i - 1))
  Next i
  For i = 1 To Nop_cal * 2
    Write #iFileNo, Val(Cal_b1(i - 1))
  Next i
  For i = 1 To Nop_cal * 2
    Write #iFileNo, Val(Cal_c1(i - 1))
  Next i
  For i = 1 To Nop_cal * 2
    Write #iFileNo, Val(Cal_a2(i - 1))
  Next i
  For i = 1 To Nop_cal * 2
    Write #iFileNo, Val(Cal_b2(i - 1))
  Next i
  For i = 1 To Nop_cal * 2
    Write #iFileNo, Val(Cal_c2(i - 1))
  Next i
  Close #iFileNo
      
  MsgBox "Saving Calibration Coefficient File Completion", vbOKOnly, "Calibration"
    
Prog_end: End

End Sub
    
Function Cal(Standard As String) As Integer
  Dim Inp_char As Integer
  Dim bool As Long
    
  Inp_char = MsgBox("Connect " & Standard & _
                    " standard to DUT port.", _
                     vbOKCancel, "Calibration")
   
  If Inp_char = vbOK Then
    Select Case Standard
    Case "Open"
      bool = CalMeasure(CalOpen)
    Case "Short"
      bool = CalMeasure(CalShort)
    Case "Load"
      bool = CalMeasure(CalLoad)
    Case "Low-loss C"
      bool = CalMeasure(CalLowLossC)
    End Select
            
    If bool = 0 Then
      MsgBox Standard & " Calibration aborted!", vbOKOnly, "Calibration"
      Cal = -1
    Else
      Cal = 0
    End If
  Else
    Cal = -1
  End If
    
End Function
    
Sub Inp_data(Mes As String, Inp_val As Double)
        
  Inp_val = Val(InputBox(Mes, "Input values"))
        
End Sub
