Attribute VB_Name = "circuit"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: circuit.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim trc1 As Integer, trc2 As Integer, nop As Integer
  Dim swp_count As Integer, data_size As Integer
  Dim equ_model As String, start_f As String, stop_f As String
  Dim file As String, buff As String
  Dim r1 As Double, c1 As Double, l1 As Double, c0 As Double
  Dim sim_data_z As Variant, sim_data_thd As Variant
  Dim i As Integer, swp_bool As Integer, bool As Integer
  Dim fileNum As Integer
  Dim msg As String
  
  start_f = "50MHZ"
  stop_f = "150MHZ"
  nop = 201
  trc1 = 1
  trc2 = 2
  swp_count = 1
  equ_model = "E"
  
  ' E4991A settings
  
  SCPI.Output "SYST:PRES"
  '
  SCPI.Output "DISP:TRAC" & CStr(trc1) & " ON"
  SCPI.Output "CALC" & CStr(trc1) & ":FORM Z"
  SCPI.Output "DISP:TRAC" & CStr(trc2) & " ON"
  SCPI.Output "CALC" & CStr(trc2) & ":FORM ZPH"
  SCPI.Output "CALC" & CStr(trc2) & ":FORM:UNIT:ANGL DEG"
  
  SCPI.Output "SWE:TYPE LIN"
  SCPI.Output "FREQ:STAR " & start_f
  SCPI.Output "FREQ:STOP " & stop_f
  SCPI.Output "SWE:POIN " & CStr(nop)
  SCPI.Output "CALC:AVER:COUN " & CStr(swp_count)
  SCPI.Output "CALC:AVER ON"
  
  SCPI.Output "TRIG:SOUR INT"
  SCPI.Output "INIT:CONT OFF"
  SCPI.Output "ABOR"
  
  swp_bool = SCPI.Query("CALC:AVER?")
  If swp_bool = 1 Then SCPI.Output "CALC:AVER:CLE"
  
  bool = SingleMeasure
  If bool = 0 Then
    MsgBox ("Sweep Aborted")
  ElseIf bool = 1 Then
    SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:AUTO"
    SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:AUTO"
    
    SCPI.Output "CALC" & CStr(trc1) & ":EPAR:CIRC " & equ_model
    SCPI.Output "CALC" & CStr(trc1) & ":EPAR"
    
    r1 = SCPI.Query("CALC" & CStr(trc1) & ":DATA:EPAR? EQR1")
    c1 = SCPI.Query("CALC" & CStr(trc1) & ":DATA:EPAR? EQC1")
    l1 = SCPI.Query("CALC" & CStr(trc1) & ":DATA:EPAR? EQL1")
    c0 = SCPI.Query("CALC" & CStr(trc1) & ":DATA:EPAR? EQC0")
    
    msg = "Equivarent Circuit Parameters" & vbCrLf & vbCrLf & "R1=" & CStr(r1) & vbCrLf & "C1=" & CStr(c1) & vbCrLf & "L1=" & CStr(l1) & vbCrLf & "C0=" & CStr(c0)
    MsgBox (msg)
    
    SCPI.Output "CALC" & CStr(trc1) & ":EPAR:SIM"
    SCPI.Output "CALC" & CStr(trc2) & ":EPAR:SIM"
    SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:FOR AND"
    SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:FOR AND"
    SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:AUTO"
    SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:AUTO"
    
    SCPI.Output "FORM:DATA ASC"
    SCPI.Output "CALC" & CStr(trc1) & ":DATA? FMEM"
    SCPI.Enter sim_data_z, "#"
    SCPI.Output "CALC" & CStr(trc2) & ":DATA? FMEM"
    SCPI.Enter sim_data_thd, "#"
    
    file = "a:\equ_trace"
    fileNum = FreeFile
    Open file For Output As #fileNum
    For i = 1 To nop
      Print #fileNum, Val(sim_data_z(i - 1))
    Next i
    For i = 1 To nop
      Print #fileNum, Val(sim_data_thd(i - 1))
    Next i
    Close #fileNum
  End If
  
  End
End Sub
