Attribute VB_Name = "com_meas"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: com_meas.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim buff As String, file As String
  Dim Fixt_type As String, Cal_point As String
  Dim Comp_a As Variant, Comp_b As Variant
  Dim E_length As Double
  Dim Open_g As Double, Open_c As Double
  Dim Short_r As Double, Short_l As Double
  Dim Result As Integer, Nop_comp As Integer, Inp_char As Integer
  Dim iFileNo As Integer, i As Integer
    
  Fixt_type = "USER"    'USER/FXT16191A/FXT16192A/...
  Cal_point = "FIX"     'FIX/FUS/USER
    
  SCPI.Output "SENS:CORR2:FIXT " & Fixt_type
  SCPI.Output "SENS:CORR2:COLL:FPO " & Cal_point
    
  If Fixt_type = "USER" Then
    Call Inp_data("User's Test Fixture Electrical Length(m)", E_length)
    SCPI.Output "SENS:CORR2:FIXT:EDEL:USER:DIST " & CStr(E_length)
  End If
    
  Inp_char = MsgBox("Do you want to entry the comp. standard values?", vbYesNo + vbQuestion, "Compensation")
  If Inp_char = vbYes Then
        
    SCPI.Output "SENS:CORR2:CKIT:LIST OFF"
        
    Call Inp_data("Open_G(S)", Open_g)
    Call Inp_data("Open_C(F)", Open_c)
    SCPI.Output "SENS:CORR2:CKIT:STAN1:G " & CStr(Open_g)
    SCPI.Output "SENS:CORR2:CKIT:STAN1:C " & CStr(Open_c)
        
    Call Inp_data("Short_R(ohm)", Short_r)
    Call Inp_data("Short_L(H)", Short_l)
    SCPI.Output "SENS:CORR2:CKIT:STAN2:R " & CStr(Short_r)
    SCPI.Output "SENS:CORR2:CKIT:STAN2:L " & CStr(Short_l)
        
  End If
    
  Result = Fixt_comp("Open")
  If Result <> 0 Then GoTo Prog_end
  
  Result = Fixt_comp("Short")
  If Result <> 0 Then GoTo Prog_end
  
  SCPI.Output "SENS:CORR2:COLL:SAVE"
  buff = SCPI.Query("*OPC?")
  MsgBox "All compen-data measurement completion", vbOKOnly, "Compensation"
    
  SCPI.Output "FORM:DATA ASC"
  SCPI.Output "DATA:CMP1?"
  SCPI.Enter Comp_a, "#"
  SCPI.Output "DATA:CMP2?"
  SCPI.Enter Comp_b, "#"
        
  SCPI.Output "SWE:POIN?"
  SCPI.Enter Nop_comp
    
  iFileNo = FreeFile
  file = "COMP_COEF"
  Open file For Output As iFileNo
  For i = 0 To Nop_comp - 1
    Write #iFileNo, Val(Comp_a(2 * i)), Val(Comp_a(2 * i + 1))
  Next i

  For i = 0 To Nop_comp - 1
    Write #iFileNo, Val(Comp_b(2 * i)), Val(Comp_b(2 * i + 1))
  Next i
  Close #iFileNo
  MsgBox "Saving Compensation Coefficient File Completion", vbOKOnly, "Compensation"
    
Prog_end: End

    End Sub
 
Function Fixt_comp(Standard As String) As Integer
  Dim Inp_char As Integer
  Dim bool As Long
  
  Inp_char = MsgBox("Connect " & Standard & _
                    " standard to electrode plate on the test fixture.", _
                      vbOKCancel, "Compensation")
    
  If Inp_char = vbOK Then
    Select Case Standard
    Case "Open"
      bool = CompenMeasure(CompenOpen)
    Case "Short"
      bool = CompenMeasure(CompenShort)
    End Select
    If bool = 0 Then
      MsgBox Standard & " Compensation aborted!", vbOKOnly, "Compensation"
      Fixt_comp = -1
    Else
      Fixt_comp = 0
    End If
  Else
    Fixt_comp = -1
  End If
  
End Function
    
Sub Inp_data(Mes As String, Inp_val As Double)
        
  Inp_val = Val(InputBox(Mes, "Input values"))
        
End Sub
