Attribute VB_Name = "lim_test"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: lim_test.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim mkr1_stim(8) As Double, mkr1_upp(8) As Double, mkr1_low(8) As Double
  Dim mkr1_meas(8) As Double
  Dim ref_stim As Double, ref_upp As Double, ref_low As Double, ref_meas As Double
  Dim ref_judge As String, mkr1_judge(8) As String, all_judge As String
  Dim trc1 As Integer, trc2 As Integer, mkr As Integer
  Dim swp_bool As Integer, bool As Integer
  Dim file As String
  
  trc1 = 1
  trc2 = 2
  
  ref_stim = 1000000#
  mkr1_stim(1) = 5000000#
  mkr1_stim(2) = 10000000#
  mkr1_stim(3) = 50000000#
  mkr1_stim(4) = 100000000#
  mkr1_stim(5) = 500000000#
  mkr1_stim(6) = 1000000000#
  mkr1_stim(7) = 2000000000#
  mkr1_stim(8) = 3000000000#
  
  ref_upp = 80
  mkr1_upp(1) = 80
  mkr1_upp(2) = 70
  mkr1_upp(3) = 70
  mkr1_upp(4) = 70
  mkr1_upp(5) = 70
  mkr1_upp(6) = 80
  mkr1_upp(7) = 80
  mkr1_upp(8) = 80
  
  ref_low = 20
  mkr1_low(1) = 20
  mkr1_low(2) = 30
  mkr1_low(3) = 30
  mkr1_low(4) = 30
  mkr1_low(5) = 30
  mkr1_low(6) = 20
  mkr1_low(7) = 20
  mkr1_low(8) = 20
  
  ' E4991A settings
  
  SCPI.Output "SYST:PRES"
  '
  SCPI.Output "DISP:TRAC" & CStr(trc1) & " ON"
  SCPI.Output "DISP:TRAC" & CStr(trc2) & " OFF"
  SCPI.Output "CALC" & CStr(trc1) & ":FORM Z"
  
  SCPI.Output "SWE:TYPE LOG"
  
  SCPI.Output "CALC" & CStr(trc1) & ":MARK:REF ON"
  SCPI.Output "CALC" & CStr(trc1) & ":MARK:REF:FUNC:DOM:LIM ON"
  SCPI.Output "CALC" & CStr(trc1) & ":MARK:REF:X " & CStr(ref_stim)
  SCPI.Output "CALC" & CStr(trc1) & ":MARK:REF:FUNC:DOM:LIM:UP " & CStr(ref_upp)
  SCPI.Output "CALC" & CStr(trc1) & ":MARK:REF:FUNC:DOM:LIM:LOW " & CStr(ref_low)
  
  For mkr = 1 To 8
    SCPI.Output "CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & " ON"
    SCPI.Output "CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & ":FUNC:DOM:LIM ON"
    SCPI.Output "CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & ":X " & CStr(mkr1_stim(mkr))
    SCPI.Output "CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & ":FUNC:DOM:LIM:UP " & CStr(mkr1_upp(mkr))
    SCPI.Output "CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & ":FUNC:DOM:LIM:LOW " & CStr(mkr1_low(mkr))
  Next mkr
  
  SCPI.Output "CALC" & CStr(trc1) & ":MARK:FUNC:DOM:LIM:ALL ON"
  
  SCPI.Output "TRIG:SOUR INT"
  SCPI.Output "INIT:CONT OFF"
  SCPI.Output "ABOR"
  
  swp_bool = SCPI.Query("CALC:AVER?")
  If swp_bool = 1 Then SCPI.Output "CALC:AVER:CLE"
  
  bool = SingleMeasure
  If bool = 0 Then
    MsgBox ("Sweep Aborted")
  ElseIf bool = 1 Then
    SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:AUTO"
    
    SCPI.Output ("CALC" & CStr(trc1) & ":MARK:REF:Y?")
    SCPI.Enter ref_meas
    SCPI.Output ("CALC" & CStr(trc1) & ":MARK:REF:FUNC:DOM:LIM:RES?")
    SCPI.Enter ref_judge
    
    For mkr = 1 To 8
      SCPI.Output ("CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & ":Y?")
      SCPI.Enter mkr1_meas(mkr)
      SCPI.Output ("CALC" & CStr(trc1) & ":MARK" & CStr(mkr) & ":FUNC:DOM:LIM:RES?")
      SCPI.Enter mkr1_judge(mkr)
    Next mkr
    
    all_judge = SCPI.Query("CALC" & CStr(trc1) & ":MARK:FUNC:DOM:LIM:ALL:RES?")
    
    file = "a:\lim_res.txt"
    Open file For Output As #1
    Print #1, "Marker Limit Test Results"
    Print #1, ""
    Print #1, " Mkr       freq.[MHz]      lower        actual       upper        judge"
    Print #1, "------------------------------------------------------------------------"
    Print #1, "R", ref_stim / 1000000#, ref_low, ref_meas, ref_upp, ref_judge
    For mkr = 1 To 8
      Print #1, mkr, mkr1_stim(mkr) / 1000000#, mkr1_low(mkr), mkr1_meas(mkr), mkr1_upp(mkr), mkr1_judge(mkr)
    Next mkr
    Print #1, "------------------------------------------------------------------------"
    Print #1, " total                                                           " & all_judge
    Close #1
    
    MsgBox ("Marker Limit Test: " & all_judge)
  End If
  
  End
  
End Sub

