Attribute VB_Name = "Save_rec"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: save_rec.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim msg1 As String, msg2 As String, msg3 As String
  Dim msg4 As String, msg5 As String, msg6 As String
  Dim msg7 As String, msg8 As String, msg9 As String
  Dim msg10 As String
  Dim ans As String
  
menu:
  msg1 = "           Save/Recall Menu" & vbCrLf
  msg2 = "------------------------------" & vbCrLf
  msg3 = "1: returns/changes current holder" & vbCrLf
  msg4 = "2: saves state file" & vbCrLf
  msg5 = "3: recalls state file" & vbCrLf
  msg6 = "4: saves data file" & vbCrLf
  msg7 = "5: recall data file" & vbCrLf
  msg8 = "6: saves CITIfile" & vbCrLf
  msg9 = "7: saves graphics data file" & vbCrLf
  msg10 = "8: quit" & vbCrLf
  ans = InputBox(msg1 & msg2 & msg3 & msg4 & msg5 & msg6 & msg7 & msg8 & msg9 & msg10, "file menu")
  
  Select Case ans
  Case "1"
    Call chn_curr_holder
  Case "2"
    Call save_state
  Case "3"
    Call recall_state
  Case "4"
    Call save_data
  Case "5"
    Call recall_data
  Case "6"
    Call save_citi
  Case "7"
    Call save_graphics
  Case "8", ""
    GoTo menu_end
  End Select
  
  GoTo menu
  
menu_end:
  End
End Sub

Private Sub chn_curr_holder()
  Dim msg As String, holder As String, err_mes As String
  Dim err_no As Integer
  
  SCPI.Output "MMEM:CDIR?"
  SCPI.Enter holder
input_name:
  msg = "current holder name: " & holder & vbCrLf & vbCrLf & "Do you want to change the current holder?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbYes Then
    msg = "Input new current holder name you wish."
    holder = InputBox(msg, "holder name")
    If holder = "" Then GoTo input_end
    holder = """" & holder & """"
    SCPI.Output "*CLS"
    SCPI.Output "MMEM:CDIR " & holder
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("new holder name: " & holder)
    End If
  End If
input_end:
End Sub

Private Sub save_state()
  Dim msg As String, file As String, err_mes As String
  Dim err_no As Integer
  
input_name:
  msg = "Input the state file name without extension you wish to save."
  file = InputBox(msg, "file name")
  If file = "" Then GoTo input_end
  file = """" & file & """"
  msg = "file name : " & file & vbCrLf & vbCrLf & "Do you want to change the file name again?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbNo Then
    SCPI.Output "*CLS"
    SCPI.Output "MMEM:STOR " & file
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("save done")
    End If
  ElseIf ans = vbYes Then
    GoTo input_name
  End If
input_end:
End Sub

Private Sub recall_state()
  Dim msg As String, file As String, err_mes As String
  Dim err_no As Integer
  
input_name:
  msg = "Input the state file name without extension you wish to recall."
  file = InputBox(msg, "file name")
  If file = "" Then GoTo input_end
  file = """" & file & """"
  msg = "file name : " & file & vbCrLf & vbCrLf & "Do you want to change the file name again?"
  msg = "Do you want to change file name again?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbNo Then
    SCPI.Output "*CLS"
    SCPI.Output "MMEM:LOAD " & file
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("recall done")
    End If
  ElseIf ans = vbYes Then
    GoTo input_name
  End If
input_end:
End Sub

Private Sub save_data()
  Dim msg As String, file As String, file_type As String
  Dim err_mes As String, bool As String
  Dim i As Integer, err_no As Integer
  
  For i = 1 To 4
    Select Case i
    Case 1
      ans = MsgBox("Do you want to save the data array?", vbYesNo)
    Case 2
      ans = MsgBox("Do you want to save the data trace array?", vbYesNo)
    Case 3
      ans = MsgBox("Do you want to save the memory array?", vbYesNo)
    Case 4
      ans = MsgBox("Do you want to save the memory trace array?", vbYesNo)
    End Select
    If asn = vbYes Then
      SCPI.Output "MMEM:STOR:TRAC:SEL" & CStr(i) & " ON"
    ElseIf ans = vbNo Then
      SCPI.Output "MMEM:STOR:TRAC:SEL" & CStr(i) & " OFF"
    End If
  Next i
  
  msg = "Select the File type, ASCII or Binary." & vbCrLf & vbCrLf & "Input the first letter of a word [A/B]"
  file_type = InputBox(msg, "file type")
  If file_type = "" Then GoTo input_end
  
input_name:
  msg = "Input the data file name without extension you wish to save."
  file = InputBox(msg, "file name")
  If file = "" Then GoTo input_end
  file = """" & file & """"
  msg = "file name : " & file & vbCrLf & vbCrLf & "Do you want to change the file name again?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbNo Then
    SCPI.Output "*CLS"
    If UCase(file_type) = "A" Then
      SCPI.Output "MMEM:STOR:TRAC:ASC " & file
    ElseIf UCase(file_type) = "B" Then
      SCPI.Output "MMEM:STOR:TRAC " & file
    End If
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("save done")
    End If
  ElseIf ans = vbYes Then
    GoTo input_name
  End If
input_end:
End Sub

Private Sub recall_data()
  Dim msg As String, file As String, err_mes As String
  Dim err_no As Integer
  
input_name:
  msg = "Input the binary data file file name without extension you wish to recall."
  file = InputBox(msg, "file name")
  If file = "" Then GoTo input_end
  file = """" & file & """"
  msg = "Do you want to change the file name again?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbNo Then
    SCPI.Output "*CLS"
    SCPI.Output "MMEM:LOAD:TRAC " & file
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("recall done")
    End If
  ElseIf ans = vbYes Then
    GoTo input_name
  End If
input_end:
End Sub

Private Sub save_citi()
  Dim msg1 As String, msg2 As String, msg3 As String, msg4 As String
  Dim file As String, model As String
  Dim err_mes As String, bool As String
  Dim err_no As Integer
  
input_name:  '
  msg1 = "Select the model of the CITIfile as follows [1-3];" & vbCrLf & vbCrLf
  msg2 = "1: 1 port" & vbCrLf
  msg3 = "2: 2 port Series" & vbCrLf
  msg4 = "3: 2 port Shunt"
  model = InputBox(msg1 & msg2 & msg3 & msg4, "CITIfile type")
  If model = "" Then GoTo input_end
  
  msg = "Input CITIfile name without extension you wish to save."
  file = InputBox(msg, "file name")
  If file = "" Then GoTo input_end
  file = """" & file & """"
  msg = "file name : " & file & vbCrLf & vbCrLf & "Do you want to change the file name again?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbNo Then
    SCPI.Output "*CLS"
    SCPI.Output "MMEM:STOR:CITI" & CStr(model) & " " & file
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("save done")
    End If
  ElseIf ans = vbYes Then
    GoTo input_name
  End If
input_end:
End Sub

Private Sub save_graphics()
  Dim msg As String, file As String, file_type As String
  Dim err_mes As String, bool As String
  Dim err_no As Integer
  
  msg = "Select the File type, BMP or JPEG." & vbCrLf & vbCrLf & "Input the first letter of a word [B/J]"
  file_type = InputBox(msg, "file type")
  If file_type = "" Then GoTo input_end
  
input_name:
  msg = "Input the graphics file name without extension you wish to save."
  file = InputBox(msg, "file name")
  If file = "" Then GoTo input_end
  file = """" & file & """"
  msg = "file name : " & file & vbCrLf & vbCrLf & "Do you want to change the file name again?"
  ans = MsgBox(msg, vbYesNo)
  If ans = vbNo Then
    SCPI.Output "*CLS"
    If UCase(file_type) = "B" Then
      SCPI.Output "MMEM:STOR:GRAP:BMP " & file
    ElseIf UCase(file_type) = "J" Then
      SCPI.Output "MMEM:STOR:GRAP " & file
    End If
    SCPI.Output "SYST:ERR?"
    SCPI.Enter err_no, "#"
    SCPI.Enter err_mes
    If err_no <> 0 Then
      MsgBox (err_mes & "occured")
      GoTo input_name
    ElseIf err_no = 0 Then
      MsgBox ("save done")
    End If
  ElseIf ans = vbYes Then
    GoTo input_name
  End If

input_end:

End Sub
