Attribute VB_Name = "segm_set"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: segm_set.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim no_of_segment As Integer, segm_no As Integer
  Dim nop(3) As Integer, point_avg(3) As Integer
  Dim start_f(3) As Double, stop_f(3) As Double
  Dim osc(3) As Double, dcbias(3) As Double, dcbias_lim(3) As Double
  Dim segm_count As Integer
  Dim osc_unit As String, dcbias_unit As String
    
  no_of_segment = 3
  osc_unit = "VOLT"
  dcbias_unit = "CURR"
  
  start_f(1) = 1000000#
  stop_f(1) = 100000000#
  nop(1) = 101
  point_avg(1) = 32
  osc(1) = 0.1
  dcbias(1) = 10
  dcbias_lim(1) = 0.01
  start_f(2) = 100000000#
  stop_f(2) = 1000000000#
  nop(2) = 101
  point_avg(2) = 4
  osc(2) = 0.1
  dcbias(2) = 10
  dcbias_lim(2) = 0.01
  start_f(3) = 1000000000#
  stop_f(3) = 3000000000#
  nop(3) = 51
  point_avg(3) = 4
  osc(3) = 0.1
  dcbias(3) = 10
  dcbias_lim(3) = 0.01
  
  ' Initial Setting
  
  SCPI.Output "SYST:PRES"
  SCPI.Output "SEGM:COUN " & CStr(no_of_segment)
  SCPI.Output "DISP:TEXT:STAT ON"
  SCPI.Output "SEGM:" & osc_unit & ":STAT ON"
  
  If dcbias_unit = "VOLT" Or dcbias_unit = "CURR" Then
    SCPI.Output "SEGM:" & dcbias_unit & ":OFFS:STAT ON"
    For segm_no = 1 To no_of_segment
      Call segm_tbl_bias(segm_no, start_f(segm_no), stop_f(segm_no), nop(segm_no), point_avg(segm_no), osc_unit, osc(segm_no), dcbias_unit, dcbias(segm_no), dcbias_lim(segm_no))
    Next segm_no
  ElseIf dcbias_unit = "OFF" Then
    For segm_no = 1 To no_of_segment
      Call segm_tbl(segm_no, start_f(segm_no), stop_f(segm_no), nop(segm_no), point_avg(segm_no), osc_unit, osc(segm_no))
    Next segm_no
  End If
  
  segm_coun = SCPI.Query("SEGM:COUN?")
  SCPI.Output "DISP:TEXT1:SET"
  MsgBox ("Preparation of Segment Table Finished. (No. of Segments : " & CStr(segm_coun)) & ")"
  
  End
  
End Sub

Sub segm_tbl_bias(segm_no As Integer, start_f, stop_f As Double, nop, point_avg As Integer, osc_unit As String, osc As Double, dcbias_unit As String, dcbias, dcbias_lim As Double)
  
  SCPI.Output "SEGM" & CStr(segm_no) & ":FREQ:STAR " & CStr(start_f)
  SCPI.Output "SEGM" & CStr(segm_no) & ":FREQ:STOP " & CStr(stop_f)
  SCPI.Output "SEGM" & CStr(segm_no) & ":SWE:POIN " & CStr(nop)
  SCPI.Output "SEGM" & CStr(segm_no) & ":AVER:COUN " & CStr(point_avg)
  SCPI.Output "SEGM" & CStr(segm_no) & ":" & osc_unit & " " & CStr(osc)
  Select Case dcbias_unit
  Case "VOLT"
    SCPI.Output "SEGM" & CStr(segm_no) & ":VOLT:OFFS " & CStr(dcbias)
    SCPI.Output "SEGM" & CStr(segm_no) & ":CURR:LIM " & CStr(dcbias_lim)
  Case "CURR"
    SCPI.Output "SEGM" & CStr(segm_no) & ":CURR:OFFS " & CStr(dcbias)
    SCPI.Output "SEGM" & CStr(segm_no) & ":VOLT:LIM " & CStr(dcbias_lim)
  End Select
  
End Sub

Sub segm_tbl(segm_no As Integer, start_f, stop_f As Double, nop, point_avg As Integer, osc_unit As String, osc As Double)
  
  SCPI.Output "SEGM" & CStr(segm_no) & ":FREQ:STAR " & CStr(start_f)
  SCPI.Output "SEGM" & CStr(segm_no) & ":FREQ:STOP " & CStr(stop_f)
  SCPI.Output "SEGM" & CStr(segm_no) & ":SWE:POIN " & CStr(nop)
  SCPI.Output "SEGM" & CStr(segm_no) & ":AVER:COUN " & CStr(point_avg)
  SCPI.Output "SEGM" & CStr(segm_no) & ":" & osc_unit & " " & CStr(osc)
  
End Sub
