Attribute VB_Name = "Setup"
'*************************************************
'* DESCRIPTION:  Agilent E4991A Sample Program
'*
'* AUTHOR:       Agilent Technologies Japan, Ltd.
'* CREATED:      4/10/2001
'* PROGRAM NAME: setup.bas
'* REVISION:     A.01.00
'*
'*     Copyright (c) Agilent Technologies,
'*              All rights reserved.
'*
'*
'*  Customer shall have the personal, non-
'* transferable rights to use, copy or modify
'* this SAMPLE PROGRAM for Customer's internal
'* operations. Customer shall use the SAMPLE
'* PROGRAM solely and exclusively for its own
'* purpose and shall not license, lease, market
'* or distribute the SAMPLE PROGRAM or
'* modification or any part thereof.
'*
'*  Agilent Technologies shall not be liable for
'* the quality, performance or behavior of the
'* SAMPLE PROGRAM. Agilent Technologies especially
'* disclaims that the operation of the SAMPLE
'* PROGRAM shall be uninterrupted or error free.
'* This SAMPLE PROGRAM is provided AS IS.
'*
'*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
'* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'* A PARTICULAR PURPOSE.
'*
'*  Agilent Technologies shall not be liable for
'* any infringement of any patent, trademark,
'* copyright or other proprietary rights by the
'* SAMPLE PROGRAM or its use. Agilent Technologies
'* does not warrant that the SAMPLE PROGRAM is
'* free from infringements or such rights of third
'* parties. However, Agilent Technologies will not
'* knowingly infringe or deliver a software that
'* infringes the patent, trademark, copyright or
'* other proprietary right of a third party.
'*
'*************************************************

Sub Main()
  Dim trc1 As Integer, trc2 As Integer, trc3 As Integer
  Dim trc4 As Integer, trc5 As Integer
  Dim nop As Integer, sweep_avg_coun As Integer
  Dim start_freq As Double, stop_freq As Double, sweep_delay As Double
  Dim sour_curr As Double, dc_bias_v As Double, dc_bias_i_lim As Double
  Dim full_scale1 As Double, full_scale2 As Double, full_scale4 As Double
  Dim ref_val1 As Double, ref_val2 As Double, ref_val4 As Double
  Dim ref_pos1 As Double, ref_pos2 As Double, ref_pos4 As Double
  Dim top_scale1 As Double, top_scale2 As Double, top_scale4 As Double
  Dim bottom_scale1 As Double, bottom_scale2 As Double, bottom_scale4 As Double
  Dim trac1 As String, trac2 As String, trac3 As String
  Dim trac4 As String, trac5 As String
  Dim m_para1 As String, m_para2 As String, m_para4 As String
  Dim disp_form1 As String, disp_form2 As String, disp_form4 As String
  Dim disp_y_spac1 As String, disp_y_spac2 As String, disp_y_spac4 As String
  Dim phase_unit1 As String, phase_unit2 As String, phase_unit4 As String
  Dim phase_exp1 As String, phase_exp2 As String, phase_exp4 As String
  Dim sweep_type As String, sweep_dir As String
  Dim sweep_avg As String, point_avg As String
  Dim sweep_t_auto As String, sour_curr_mode As String
  Dim list_page1 As String, list_page2 As String, list_page4 As String
  Dim disp_trac1 As String, disp_trac2 As String, disp_trac4 As String
  Dim buff As String
  
  trc1 = 1
  trc2 = 2
  trc3 = 3
  trc4 = 4
  trc5 = 5
  
  trac1 = "ON"
  trac2 = "ON"
  trac3 = "OFF"
  trac4 = "ON"
  trac5 = "OFF"
  m_para1 = "Z"
  m_para2 = "ZPH"
  m_para4 = "RC"
  disp_form1 = "RECT"
  disp_form2 = "RECT"
  disp_form4 = "SMIT"
  disp_y_spac1 = "LOG"
  disp_y_spac2 = "LIN"
  phase_unit2 = "DEG"
  phase_exp2 = "ON"
  
  sweep_type = "LOG"
  start_freq = 100000000#
  stop_freq = 3000000000#
  nop = 201
  sweep_dir = "UP"
  sweep_avg_coun = 16
  sweep_avg = "ON"
  point_avg = "ON"
  sweep_t_auto = "ON"
  sweep_delay = 0
  sour_curr_mode = "FIX"
  sour_curr = 0.001
  dc_bias_v = 15
  dc_bias_i_lim = 0.01
  
  list_page1 = "OFF"
  list_page2 = "OFF"
  list_page4 = "OFF"
  disp_trac1 = "DATA"
  disp_trac2 = "DATA"
  disp_trac4 = "DATA"
  top_scale1 = 100
  bottom_scale1 = 0.1
  full_scale2 = 500
  ref_val2 = 0
  ref = pos2 = 50
  
  SCPI.Output "SYST:PRES"
  
  ' Measurement Mode & Parameter & Disp Format Setting
  
  SCPI.Output "MODE IMP"
  
  SCPI.Output "DISP:TRAC" & CStr(trc1) & " " & trac1
  SCPI.Output "CALC" & CStr(trc1) & ":FORM " & m_para1
  SCPI.Output "DISP:TRAC" & CStr(trc1) & ":GRAT:FORM " & disp_form1
  SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:SPAC " & disp_y_spac1
  
  SCPI.Output "DISP:TRAC" & CStr(trc2) & " " & trac2
  SCPI.Output "CALC" & CStr(trc2) & ":FORM " & m_para2
  SCPI.Output "DISP:TRAC" & CStr(trc2) & ":GRAT:FORM " & disp_form2
  SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:SPAC " & disp_y_spac2
  SCPI.Output "CALC" & CStr(trc2) & ":FORM:UNIT:ANGL " & phase_unit2
  SCPI.Output "CALC" & CStr(trc2) & ":FORM:PAR:EPH " & phase_exp2
  
  SCPI.Output "DISP:TRAC" & CStr(trc4) & " " & trac4
  SCPI.Output "CALC" & CStr(trc4) & ":FORM " & m_para4
  SCPI.Output "DISP:TRAC" & CStr(trc4) & ":GRAT:FORM " & disp_form4
  
  SCPI.Output "DISP:TRAC" & CStr(trc3) & " " & trac3
  SCPI.Output "DISP:TRAC" & CStr(trc5) & " " & trac5
  
  ' Sweep & Average Setting
  
  SCPI.Output "SWE:TYPE " & sweep_type
  
  SCPI.Output "FREQ:STAR " & CStr(start_freq)
  SCPI.Output "FREQ:STOP " & CStr(stop_freq)
  
  SCPI.Output "SWE:POIN " & CStr(nop)
  SCPI.Output "SWE:DIR " & sweep_dir
  SCPI.Output "CALC:AVER:COUN " & CStr(sweep_avg_coun)
  SCPI.Output "CALC:AVER " & sweep_avg
  SCPI.Output "AVER " & point_avg
  SCPI.Output "SWE:TIME:AUTO " & sweep_t_auto
  SCPI.Output "SWE:DWEL1 " & CStr(sweep_delay)
  
  ' Source Setting
  
  SCPI.Output "SOUR:CURR:MODE " & sour_curr_mode
  SCPI.Output "SOUR:CURR " & CStr(sour_curr)
  SCPI.Output "SOUR:VOLT:OFFS " & CStr(dc_bias_v)
  SCPI.Output "SOUR:CURR:LIM:OFFS " & CStr(dc_bias_i_lim)
  '
  ' Trace1 Setting
  '
  SCPI.Output "DISP:TRAC" & CStr(trc1) & ":TEXT " & list_page1
  
  SCPI.Output "CALC" & CStr(trc1) & ":MATH:FUNC " & disp_trac1
  SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:TOP " & CStr(top_scale1)
  SCPI.Output "DISP:TRAC" & CStr(trc1) & ":Y:BOTT " & CStr(bottom_scale1)
  
  ' Trace2 Setting
  
  SCPI.Output "DISP:TRAC" & CStr(trc2) & ":TEXT " & list_page2
  SCPI.Output "CALC" & CStr(trc2) & ":MATH:FUNC " & disp_trac2
  SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:FULL " & CStr(full_scale2)
  SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:RLEV " & CStr(ref_val2)
  SCPI.Output "DISP:TRAC" & CStr(trc2) & ":Y:RPOS " & CStr(ref_pos2)
  
  ' Trace4 Setting
  
  SCPI.Output "DISP:TRAC" & CStr(trc4) & ":TEXT " & list_page4
  SCPI.Output "CALC" & CStr(trc4) & ":MATH:FUNC " & disp_trac4
  
  ' DC Bias ON
  
  SCPI.Output "SOUR:VOLT:OFFS:STAT ON"
  
  buff = SCPI.Query("*OPC?")
  
  MsgBox ("Measurement Condition Setup Complete")
  
  End
  
End Sub
